<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/4/3 11:58
 */

namespace common\components;

use common\classes\Common;
use common\models\Users;
use Yii;

class Command extends yii\base\Component
{
    /**
     * send login message
     * @param Users $user
     * @param string $action
     */
    public function login(Users $user, $action = 'undefined'){
        if(!isset(self::LOGIN_ACTION_NAME[$action]))
            return;
        if(!empty($user->User_Desc))
            $name = $user->User_Name . '/' . $user->User_Desc;
        else
            $name = $user->User_Name;
        $body = [
            'type' => 'login_info',
            'uid' => $user->User_ID,
            'msg' => [
                'keyword1' => $name,
                'keyword2' => 'iDste控制台',
                'keyword3' => date("m-d H:i"),
                'remark' => "登录方式：". self::LOGIN_ACTION_NAME[$action]
            ],
            'level' => 'info'
        ];
        $port =  Common::MSG_WORKER_PORT_START + rand(0,  Common::MSG_WORKER_COUNT - 1);
        $this->send($port, $body);
    }
}