<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/4/3 11:58
 */

namespace common\components;

use Yii;

class Network extends yii\base\Component
{
    private $cards;
    const ROUTE_FILE_PATH = '/etc/network/if-up.d/idste-route';
    public function __construct(array $config = [])
    {
        parent::__construct($config);
        $this->cards = [];
        if ($handle = opendir('/sys/class/net')) {
            while (false != ($entry = readdir($handle))) {
                if ($entry == 'lo' || $entry == '.' || $entry == '..')
                    continue;
                $this->cards[] = $entry;
            }
        }
    }

    /**
     * get network cards infomation(config and state)
     * @return array
     */
    public function ipView()
    {
        $state = [];
        $config = [];
        foreach ($this->cards as $card) {
            $temp = [
                'mac' => '',
                'address' => '',
                'netmask' => ''
            ];
            $fp = fopen('/sys/class/net/' . $card . '/address', 'r');
            $temp['mac'] = fread($fp, 17);
            fclose($fp);
            do {
                $ip = exec("ifconfig " . $card . " | sed -n '/inet addr:/p' | awk -F'[: ]+' '{print $4}'");
                if(ip2long($ip) === false)
                    break;
                $temp['address'] = $ip;
                $netmask = exec("ifconfig " . $card . " | sed -n '/Mask:/p' | awk -F'[: ]+' '{print $8}'");
                if(ip2long($netmask) === false)
                    break;
                $temp['netmask'] = $netmask;
            } while (false);
            $state[$card] = $temp;
        }
        $output = [];
        exec('cat /etc/network/interfaces', $output);
        $lines = [];
        foreach ($output as $line) {
            $line = strtolower(trim($line));
            if (!empty($line) && !preg_match('/^#/', $line))
                $lines[] = $line;
        }
        foreach ($this->cards as $card) {
            for ($i = 0; $i < count($lines); $i++) {
                if (preg_match("/auto[ ]+$card/", $lines[$i])) {
                    $i++;
                    $temp = [];
                    for ($j = $i; $j < count($lines); $j++) {
                        $eles = preg_split('/[ ]+/', $lines[$j]);
                        if (count($eles) < 2)
                            break;
                        if ($eles[0] == 'iface' && $eles[1] == $card) {
                            if (count($eles) !== 4)
                                break;
                            if ($eles[3] == 'static')
                                $temp['type'] = 'static';
                            else if ($eles[3] == 'dhcp') {
                                $temp['type'] = 'dhcp';
                                break;
                            } else
                                break;
                        } else if (!in_array($eles[0], ['address', 'netmask']))
                            break;
                        if (ip2long($eles[1]) !== false)
                            $temp[$eles[0]] = $eles[1];
                        else
                            continue;
                    }
                    $config[$card] = $temp;
                    break;
                }
            }
        }
        return ['config' => $config, 'state' => $state];
    }

}